#include <SFML/Graphics.hpp>
#include <vector>
using namespace sf;

//------------------------------------------------------------------------------

class Axis  //  : public Drawable
{
public:
    std::vector<Vertex> vertices;
    Axis(int d, Vertex xy, int l, int n=0);
private:
    //enum Orientation { x, y };
    Vertex start;
    int length;
    int number_of_notches;
};

Axis::Axis(int d, Vertex xy, int l, int n)
{
    switch (d)
    {
    case 0:  //Axis::x:
    {
        xy.color= Color(255,255,0);
        vertices.push_back(xy);
        vertices.push_back(Vertex(Vector2f(xy.position.x+l,xy.position.y),Color(255,255,0)));
        // axis line
        if (1<n)        // add notches
        {
            int deltaX = l/n;
            int x = xy.position.x+deltaX;  // x-coord of first notch
            for (int i = 0; i<n; ++i)
            {
                vertices.push_back(Vertex(Vector2f(x,xy.position.y),Color(255,255,0)));
                vertices.push_back(Vertex(Vector2f(x,xy.position.y-10),Color(255,255,0)));
                x += deltaX;
            }
        }

//        // label under the line
//        label.move(length/3,xy.y+20);
        break;
    }
    case 1:  //Axis::y:
    {
        xy.color= Color(255,255,0);
        vertices.push_back(xy);
        vertices.push_back(Vertex(Vector2f(xy.position.x,xy.position.y-l),Color(255,255,0)));

        if (1<n)        // add notches
        {
            int deltaY = l/n;
            int y = xy.position.y-deltaY;  // x-coord of first notch
            for (int i = 0; i<n; ++i)
            {
                vertices.push_back(Vertex(Vector2f(xy.position.x,y),Color(255,255,0)));
                vertices.push_back(Vertex(Vector2f(xy.position.x+10,y),Color(255,255,0)));
                y -= deltaY;
            }
        }
        break;
    }
    }
}
