
#include "Graph.h"
#include <ctime>
#include <cstdlib>
#include <iostream>
///https://www.sfml-dev.org/tutorials/2.4/graphics-vertex-array.php
using namespace sf;

int main() {
    srand(time(0));
    unsigned wWidth = 640, wHeight = 480, margin = 10;
    const unsigned int kWidth = 50, kHeight = 50;

    RenderWindow window(VideoMode(wWidth, wHeight), "SFML works!");

    Axis ax(0, Vector2f(margin, wHeight/2), wWidth-2*margin, 10);
    Axis ay(1, Vector2f(wWidth/2, wHeight-margin), wHeight-2*margin, 10);


//sf::Vertex vertices[2] =
//{
//    sf::Vertex(...),
//    sf::Vertex(...)
//};

//window.draw(vertices, 2, sf::Lines);

    //window.draw(vertices, 2, sf::Lines);*/
    //double x{0},y{0},xinc{0.4354},yinc{0.843};
    String buffer;

    CircleShape circleShape(50,5);
    circleShape.setFillColor(Color(234,234,67));
    circleShape.setOutlineColor(Color(12,56,90));
    circleShape.setOutlineThickness(4);

    RectangleShape rectShape(Vector2f(50,50));
    rectShape.setFillColor(Color(86,190,20));
    rectShape.setPosition(Vector2f(100,100));
    circleShape.setPosition(Vector2f(200,200));
    circleShape.setOrigin(25,25);
    circleShape.rotate(45);
    rectShape.rotate(120);
    Font font;
    if(!font.loadFromFile("arial.ttf"))
        std::cout << "font not loaded" << std::endl;

    Text text("Afternoon, COD!", font, 16);

    // Array size = width * height * 4;
    std::vector<Uint8> vpixels(kWidth * kHeight * 4);
    for(Uint8 i : vpixels)
    {
        i = rand()%256;
    }
    Uint8 pixels[kWidth * kHeight * 4];
    for(int i = 0; i < kWidth * kHeight * 4; ++i) {
        if((i+1)%4==0) pixels[i]=255;
        else pixels[i] =  (kHeight * i) + kWidth;
    }
    Image image;
    image.create(kWidth,kHeight,pixels);
    Texture texture;
    texture.loadFromImage(image);
    RectangleShape rShape(Vector2f(kWidth,kHeight));
    rShape.setTexture(&texture);
    rShape.setPosition(300,300);

    ConvexShape conSh(7);
    conSh.setPoint(0,Vector2f(350,200));
    conSh.setPoint(1,Vector2f(380,160));
    conSh.setPoint(2,Vector2f(370,120));
    conSh.setPoint(3,Vector2f(350,100));
    conSh.setPoint(4,Vector2f(310,130));
    conSh.setPoint(5,Vector2f(320,150));
    conSh.setPoint(6,Vector2f(340,175));


    Texture jolly;
    if(!jolly.loadFromFile("jolly.png")) return -1;
    RectangleShape rShape2(Vector2f(100,63));
    rShape2.setTexture(&jolly);
    rShape2.setPosition(400,300);

    conSh.setTexture(&jolly);
    conSh.setOutlineThickness(3);
    conSh.setOutlineColor(Color(3,5,202));
    conSh.move(20,20);

    while (window.isOpen())
    {
        Event event;
        while (window.pollEvent(event))
        {
            switch(event.type)
            {
            case Event::EventType::Closed:
                window.close();
                break;
            case Event::EventType::TextEntered:
                //Add character to string
                buffer += event.text.unicode;
                break;
            case Event::EventType::KeyReleased:
                //Change the title to current buffer
                if (event.key.code == Keyboard::Key::Return)
                {   window.setTitle(buffer);
                    buffer.clear();
                }
                break;
            default:
                break;
            }
        }
        window.clear();

        window.draw(&ax.vertices[0], ax.vertices.size(), Lines);
        window.draw(&ay.vertices[0], ay.vertices.size(), Lines);
        window.draw(circleShape);
        window.draw(rectShape);
        window.draw(text);
        window.draw(rShape);
        window.draw(rShape2);
        window.draw(conSh);
        window.display();
    }

    return 0;
}
